Index: CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -87,5 +87,5 @@
 					panel.hide();
 
-					var style = new CKEDITOR.style( config['colorButton_' + type + 'Style'], color && { color : color } );
+					var style = new CKEDITOR.style( config['colorButton_' + type + 'Style'], { color : color || 'inherit' } );
 
 					editor.fire( 'saveSnapshot' );
@@ -123,5 +123,13 @@
 					output.push( '</tr><tr>' );
 
-				var colorCode = colors[ i ];
+				var parts = colors[ i ].split( '/' ),
+					colorName = parts[ 0 ],
+					colorCode = parts[ 1 ] || colorName;
+
+				// The data can be only a color code (without #) or colorName + color code
+				// If only a color code is provided, then the colorName is the color with the hash
+				if (!parts[1])
+					colorName = '#' + colorName;
+
 				var colorLabel = editor.lang.colors[ colorCode ] || colorCode;
 				output.push(
@@ -129,5 +137,5 @@
 						'<a class="cke_colorbox" _cke_focus=1 hidefocus=true' +
 							' title="', colorLabel, '"' +
-							' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'#', colorCode, '\',\'', type, '\'); return false;"' +
+							' onclick="CKEDITOR.tools.callFunction(', clickFn, ',\'', colorName, '\',\'', type, '\'); return false;"' +
 							' href="javascript:void(\'', colorLabel, '\')"' +
 							' role="option" aria-posinset="', ( i + 2 ), '" aria-setsize="', total, '">' +
@@ -173,4 +181,8 @@
  * Defines the colors to be displayed in the color selectors. It's a string
  * containing the hexadecimal notation for HTML colors, without the "#" prefix.
+ *
+ * Since 3.3: A name may be optionally defined by prefixing the entries with the
+ * name and the slash character. For example, "FontColor1/FF9900" will be
+ * displayed as the color #FF9900 in the selector, but will be outputted as "FontColor1".
  * @type String
  * @default '000,800000,8B4513,2F4F4F,008080,000080,4B0082,696969,B22222,A52A2A,DAA520,006400,40E0D0,0000CD,800080,808080,F00,FF8C00,FFD700,008000,0FF,00F,EE82EE,A9A9A9,FFA07A,FFA500,FFFF00,00FF00,AFEEEE,ADD8E6,DDA0DD,D3D3D3,FFF0F5,FAEBD7,FFFFE0,F0FFF0,F0FFFF,F0F8FF,E6E6FA,FFF'
@@ -178,4 +190,6 @@
  * // Brazil colors only.
  * config.colorButton_colors = '00923E,F8C100,28166F';
+ * @example
+ * config.colorButton_colors = 'FontColor1/FF9900,FontColor2/0066CC,FontColor3/F00'
  */
 CKEDITOR.config.colorButton_colors =
@@ -224,4 +238,10 @@
 	{
 		element		: 'span',
-		styles		: { 'background-color' : '#(color)' }
+		styles		: { 'background-color' : '#(color)' },
+
+		// It's better to apply background color as the innermost style. (#3599)
+		childRule : function( element )
+		{
+			return false;
+		}
 	};
Index: CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/dialogs/colordialog.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/dialogs/colordialog.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/dialogs/colordialog.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/colordialog/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-( function()
+﻿( function()
 {
 	CKEDITOR.plugins.colordialog =
Index: CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js	(revision 5306)
@@ -37,5 +37,5 @@
 			this);
 
-		this._.definiton =
+		this.definition =
 		{
 			panel:
@@ -44,5 +44,5 @@
 				attributes :
 				{
-					'aria-label' : editor.lang.common.options
+					'aria-label' : editor.lang.contextmenu.options
 				}
 			}
@@ -64,5 +64,5 @@
 			else
 			{
-				menu = this._.menu = new CKEDITOR.menu( editor, this._.definiton );
+				menu = this._.menu = new CKEDITOR.menu( editor, this.definition );
 				menu.onClick = CKEDITOR.tools.bind( function( item )
 				{
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialog/dialogDefinition.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialog/dialogDefinition.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialog/dialogDefinition.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5306)
@@ -336,5 +336,5 @@
 				processed = 1;
 			}
-			else if ( keystroke == CKEDITOR.ALT + 121 && !me._.tabBarMode )
+			else if ( keystroke == CKEDITOR.ALT + 121 && !me._.tabBarMode && me.getPageCount() > 1 )
 			{
 				// Alt-F10 puts focus into the current tab item in the tab bar.
@@ -506,6 +506,4 @@
 		for ( i = 0 ; i < buttons.length ; i++ )
 			this._.buttons[ buttons[i].id ] = buttons[i];
-
-		CKEDITOR.skins.load( editor, 'dialog' );
 	};
 
@@ -894,15 +892,10 @@
 			page.setAttribute( 'aria-labelledby', tabId );
 
-			// If only a single page exist, a different style is used in the central pane.
-			if ( this._.pageCount === 0 )
-				this.parts.dialog.addClass( 'cke_single_page' );
-			else
-				this.parts.dialog.removeClass( 'cke_single_page' );
-
 			// Take records for the tabs and elements created.
 			this._.tabs[ contents.id ] = [ tab, page ];
 			this._.tabIdList.push( contents.id );
-			this._.pageCount++;
+			!contents.hidden && this._.pageCount++;
 			this._.lastTab = tab;
+			this.updateStyle();
 
 			var contentMap = this._.contents[ contents.id ] = {},
@@ -962,4 +955,11 @@
 		},
 
+		// Dialog state-specific style updates.
+		updateStyle : function()
+		{
+			// If only a single page shown, a different style is used in the central pane.
+			this.parts.dialog[ ( this._.pageCount === 1 ? 'add' : 'remove' ) + 'Class' ]( 'cke_single_page' );
+		},
+
 		/**
 		 * Hides a page's tab away from the dialog.
@@ -971,7 +971,13 @@
 		{
 			var tab = this._.tabs[id] && this._.tabs[id][0];
-			if ( !tab )
+			if ( !tab || this._.pageCount == 1 )
 				return;
+			// Switch to other tab first when we're hiding the active tab.
+			else if ( id == this._.currentTabId )
+				this.selectPage( getPreviousVisibleTab.call( this ) );
+
 			tab.hide();
+			this._.pageCount--;
+			this.updateStyle();
 		},
 
@@ -988,4 +994,6 @@
 				return;
 			tab.show();
+			this._.pageCount++;
+			this.updateStyle();
 		},
 
@@ -1270,9 +1278,12 @@
 	var defaultDialogDefinition =
 	{
-		resizable : CKEDITOR.DIALOG_RESIZE_NONE,
+		resizable : CKEDITOR.DIALOG_RESIZE_BOTH,
 		minWidth : 600,
 		minHeight : 400,
 		buttons : [ CKEDITOR.dialog.okButton, CKEDITOR.dialog.cancelButton ]
 	};
+
+	// The buttons in MacOS Apps are in reverse order #4750
+	CKEDITOR.env.mac && defaultDialogDefinition.buttons.reverse();
 
 	// Tool function used to return an item from an array based on its id
@@ -2785,8 +2796,9 @@
 		openDialog : function( dialogName, callback )
 		{
-			var dialogDefinitions = CKEDITOR.dialog._.dialogDefinitions[ dialogName ];
+			var dialogDefinitions = CKEDITOR.dialog._.dialogDefinitions[ dialogName ],
+					dialogSkin = this.skin.dialog;
 
 			// If the dialogDefinition is already loaded, open it immediately.
-			if ( typeof dialogDefinitions == 'function' )
+			if ( typeof dialogDefinitions == 'function' && dialogSkin._isLoaded )
 			{
 				var storedDialogs = this._.storedDialogs ||
@@ -2810,12 +2822,29 @@
 
 			body.setStyle( 'cursor', 'wait' );
-			CKEDITOR.scriptLoader.load( CKEDITOR.getUrl( dialogDefinitions ), function()
-				{
-					// In case of plugin error, mark it as loading failed.
-					if ( typeof CKEDITOR.dialog._.dialogDefinitions[ dialogName ] != 'function' )
-							CKEDITOR.dialog._.dialogDefinitions[ dialogName ] =  'failed';
-					me.openDialog( dialogName, callback );
-					body.setStyle( 'cursor', cursor );
-				} );
+
+			function onDialogFileLoaded( success )
+			{
+				var dialogDefinition = CKEDITOR.dialog._.dialogDefinitions[ dialogName ],
+						skin = me.skin.dialog;
+
+				// Check if both skin part and definition is loaded.
+				if ( !skin._isLoaded || loadDefinition && typeof success == 'undefined' )
+					return;
+
+				// In case of plugin error, mark it as loading failed.
+				if ( typeof dialogDefinition != 'function' )
+					CKEDITOR.dialog._.dialogDefinitions[ dialogName ] = 'failed';
+
+				me.openDialog( dialogName, callback );
+				body.setStyle( 'cursor', cursor );
+			}
+
+			if ( typeof dialogDefinitions == 'string' )
+			{
+				var loadDefinition = 1;
+				CKEDITOR.scriptLoader.load( CKEDITOR.getUrl( dialogDefinitions ), onDialogFileLoaded );
+			}
+
+			CKEDITOR.skins.load( this, 'dialog', onDialogFileLoaded );
 
 			return null;
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialogui/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
  * Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
  * For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -437,44 +437,36 @@
 				// Preparing for the 'elementStyle' field.
 				var dialog = this,
-					 stylesField = this.getContentElement( 'info', 'elementStyle' ),
-					 // Reuse the 'stylescombo' plugin's styles definition.
-					 customStylesConfig =  editor.config.stylesCombo_stylesSet,
-					 stylesSetName = customStylesConfig && customStylesConfig.split( ':' )[ 0 ];
-
-				if ( stylesSetName )
-				{
-					CKEDITOR.stylesSet.load( stylesSetName,
-						function( stylesSet )
+					 stylesField = this.getContentElement( 'info', 'elementStyle' );
+
+				 // Reuse the 'stylescombo' plugin's styles definition.
+				editor.getStylesSet( function( stylesDefinitions )
+				{
+					var styleName;
+
+					if ( stylesDefinitions )
+					{
+						// Digg only those styles that apply to 'div'.
+						for ( var i = 0 ; i < stylesDefinitions.length ; i++ )
 						{
-							var stylesDefinitions = stylesSet[ stylesSetName ],
-								styleName;
-
-							if ( stylesDefinitions )
-							{
-								// Digg only those styles that apply to 'div'.
-								for ( var i = 0 ; i < stylesDefinitions.length ; i++ )
-								{
-									var styleDefinition = stylesDefinitions[ i ];
-									if ( styleDefinition.element && styleDefinition.element == 'div' )
-									{
-										styleName = styleDefinition.name;
-										styles[ styleName ] = new CKEDITOR.style( styleDefinition );
-
-										// Populate the styles field options with style name.
-										stylesField.items.push( [ styleName, styleName ] );
-										stylesField.add( styleName, styleName );
-									}
-								}
+							var styleDefinition = stylesDefinitions[ i ];
+							if ( styleDefinition.element && styleDefinition.element == 'div' )
+							{
+								styleName = styleDefinition.name;
+								styles[ styleName ] = new CKEDITOR.style( styleDefinition );
+
+								// Populate the styles field options with style name.
+								stylesField.items.push( [ styleName, styleName ] );
+								stylesField.add( styleName, styleName );
 							}
-
-
-							// We should disable the content element
-							// it if no options are available at all.
-							stylesField[ stylesField.items.length > 1 ? 'enable' : 'disable' ]();
-
-							// Now setup the field value manually.
-							setTimeout( function() { stylesField.setup( dialog._element ); }, 0 );
-						} );
-				}
+						}
+					}
+
+					// We should disable the content element
+					// it if no options are available at all.
+					stylesField[ stylesField.items.length > 1 ? 'enable' : 'disable' ]();
+
+					// Now setup the field value manually.
+					setTimeout( function() { stylesField.setup( dialog._element ); }, 0 );
+				} );
 			},
 			onShow : function()
Index: CKEditor/branches/versions/3.3.x/_source/plugins/div/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/div/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/div/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/domiterator/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/domiterator/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/domiterator/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -57,4 +57,6 @@
 				});
 
+			var filters = editor.config.elementsPath_filters;
+
 			editor.on( 'selectionChange', function( ev )
 				{
@@ -69,43 +71,57 @@
 					while ( element )
 					{
-						var index = elementsList.push( element ) - 1;
-						var name;
-						if ( element.getAttribute( '_cke_real_element_type' ) )
-							name = element.getAttribute( '_cke_real_element_type' );
-						else
-							name = element.getName();
-
-						// Use this variable to add conditional stuff to the
-						// HTML (because we are doing it in reverse order... unshift).
-						var extra = '';
-
-						// Some browsers don't cancel key events in the keydown but in the
-						// keypress.
-						// TODO: Check if really needed for Gecko+Mac.
-						if ( env.opera || ( env.gecko && env.mac ) )
-							extra += ' onkeypress="return false;"';
-
-						// With Firefox, we need to force the button to redraw, otherwise it
-						// will remain in the focus state.
-						if ( env.gecko )
-							extra += ' onblur="this.style.cssText = this.style.cssText;"';
-
-						var label = editor.lang.elementsPath.eleTitle.replace( /%1/, name );
-						html.unshift(
-							'<a' +
-								' id="', idBase, index, '"' +
-								' href="javascript:void(\'', name, '\')"' +
-								' tabindex="-1"' +
-								' title="', label, '"' +
-								( ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 ) ?
-								' onfocus="event.preventBubble();"' : '' ) +
-								' hidefocus="true" ' +
-								' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', this.name, '\',', index, ', event);"' +
-								extra ,
-								' onclick="return CKEDITOR._.elementsPath.click(\'', this.name, '\',', index, ');"',
-								' role="button" aria-labelledby="' + idBase + index + '_label">',
-									name,
-									'<span id="', idBase, index, '_label" class="cke_label">' + label + '</span>',
-							'</a>' );
+						var ignore = 0;
+						for ( var i = 0; i < filters.length; i++ )
+						{
+							if ( filters[ i ]( element ) === false )
+							{
+								ignore = 1;
+								break;
+							}
+						}
+
+						if ( !ignore )
+						{
+							var index = elementsList.push( element ) - 1;
+							var name;
+							if ( element.getAttribute( '_cke_real_element_type' ) )
+								name = element.getAttribute( '_cke_real_element_type' );
+							else
+								name = element.getName();
+
+							// Use this variable to add conditional stuff to the
+							// HTML (because we are doing it in reverse order... unshift).
+							var extra = '';
+
+							// Some browsers don't cancel key events in the keydown but in the
+							// keypress.
+							// TODO: Check if really needed for Gecko+Mac.
+							if ( env.opera || ( env.gecko && env.mac ) )
+								extra += ' onkeypress="return false;"';
+
+							// With Firefox, we need to force the button to redraw, otherwise it
+							// will remain in the focus state.
+							if ( env.gecko )
+								extra += ' onblur="this.style.cssText = this.style.cssText;"';
+
+							var label = editor.lang.elementsPath.eleTitle.replace( /%1/, name );
+							html.unshift(
+								'<a' +
+									' id="', idBase, index, '"' +
+									' href="javascript:void(\'', name, '\')"' +
+									' tabindex="-1"' +
+									' title="', label, '"' +
+									( ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 ) ?
+									' onfocus="event.preventBubble();"' : '' ) +
+									' hidefocus="true" ' +
+									' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', this.name, '\',', index, ', event);"' +
+									extra ,
+									' onclick="return CKEDITOR._.elementsPath.click(\'', this.name, '\',', index, ');"',
+									' role="button" aria-labelledby="' + idBase + index + '_label">',
+										name,
+										'<span id="', idBase, index, '_label" class="cke_label">' + label + '</span>',
+								'</a>' );
+
+						}
 
 						if ( name == 'body' )
@@ -188,2 +204,16 @@
 	}
 };
+
+/**
+ * A list of filter functions to determinate whether an element should display in elements path bar.
+ * @type Array Array of functions that optionaly return 'false' to prevent the element from displaying.
+ * @default  []
+ * @example
+ *	// Prevent elements with attribute 'myAttribute' to appear in elements path.
+ *	editor.config.elementsPath_filters.push( function( element )
+ *	{
+ *		if( element.hasAttribute( 'myAttribute') )
+ *			return false;
+ *	});
+ */
+CKEDITOR.config.elementsPath_filters = [];
Index: CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -27,4 +27,17 @@
 			var doc = range.document;
 
+			// Exit the list when we're inside an empty list item block. (#5376)
+			if ( range.checkStartOfBlock() && range.checkEndOfBlock() )
+			{
+				var path = new CKEDITOR.dom.elementPath( range.startContainer ),
+						block = path.block;
+
+				if ( block.is( 'li' ) || block.getParent().is( 'li' ) )
+				{
+					editor.execCommand( 'outdent' );
+					return;
+				}
+			}
+
 			// Determine the block element to be used.
 			var blockTag = ( mode == CKEDITOR.ENTER_DIV ? 'div' : 'p' );
@@ -81,11 +94,4 @@
 			else
 			{
-
-				if ( isStartOfBlock && isEndOfBlock && previousBlock.is( 'li' ) )
-				{
-					editor.execCommand( 'outdent' );
-					return;
-				}
-
 				var newBlock;
 
@@ -220,5 +226,6 @@
 				isPre = ( startBlockTag == 'pre' );
 
-				if ( isPre )
+				// Gecko prefers <br> as line-break inside <pre> (#4711).
+				if ( isPre && !CKEDITOR.env.gecko )
 					lineBreak = doc.createText( CKEDITOR.env.ie ? '\r' : '\n' );
 				else
@@ -291,4 +298,6 @@
 	function enter( editor, mode, forceMode )
 	{
+		forceMode = editor.config.forceEnterMode || forceMode;
+
 		// Only effective within document.
 		if ( editor.mode != 'wysiwyg' )
Index: CKEditor/branches/versions/3.3.x/_source/plugins/entities/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/entities/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/entities/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/fakeobjects/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/fakeobjects/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/fakeobjects/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/filebrowser/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/filebrowser/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/filebrowser/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -379,20 +379,20 @@
 		{
 			editor._.filebrowserFn = CKEDITOR.tools.addFunction( setUrl, editor );
-
-			CKEDITOR.on( 'dialogDefinition', function( evt )
-			{
-				var definition = evt.data.definition,
-					element;
-				// Associate filebrowser to elements with 'filebrowser' attribute.
-				for ( var i in definition.contents )
-				{
-					element = definition.contents[ i ] ;
-					attachFileBrowser( evt.editor, evt.data.name, definition, element.elements );
-					if ( element.hidden && element.filebrowser )
-					{
-						element.hidden = !isConfigured( definition, element[ 'id' ], element.filebrowser );
-					}
-				}
-			} );
+		}
+	} );
+
+	CKEDITOR.on( 'dialogDefinition', function( evt )
+	{
+		var definition = evt.data.definition,
+			element;
+		// Associate filebrowser to elements with 'filebrowser' attribute.
+		for ( var i in definition.contents )
+		{
+			element = definition.contents[ i ] ;
+			attachFileBrowser( evt.editor, evt.data.name, definition, element.elements );
+			if ( element.hidden && element.filebrowser )
+			{
+				element.hidden = !isConfigured( definition, element[ 'id' ], element.filebrowser );
+			}
 		}
 	} );
Index: CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/find/dialogs/find.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -68,6 +68,9 @@
 	var findDialog = function( editor, startupPage )
 	{
-		// Style object for highlights.
-		var highlightStyle = new CKEDITOR.style( editor.config.find_highlight );
+		// Style object for highlights: (#5018)
+		// 1. Defined as full match style to avoid compromising ordinary text color styles.
+		// 2. Must be apply onto inner-most text to avoid conflicting with ordinary text color styles visually.
+		var highlightStyle = new CKEDITOR.style( CKEDITOR.tools.extend( { fullMatch : true, childRule : function(){ return false; } },
+			editor.config.find_highlight ) );
 
 		/**
@@ -82,6 +85,5 @@
 			var walker =
 				new CKEDITOR.dom.walker( range );
-			walker[ matchWord ? 'guard' : 'evaluator' ] =
-				guardDomWalkerNonEmptyTextNode;
+			walker[ 'evaluator' ] = guardDomWalkerNonEmptyTextNode;
 			walker.breakOnFalse = true;
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/find/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/find/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/find/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/flash/dialogs/flash.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/flash/dialogs/flash.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/flash/dialogs/flash.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -266,10 +266,13 @@
 				}
 
-				// Apply or remove flash parameters.
-				var extraStyles = {};
-				this.commitContent( objectNode, embedNode, paramMap, extraStyles );
+				// A subset of the specified attributes/styles
+				// should also be applied on the fake element to
+				// have better visual effect. (#5240)
+				var extraStyles = {}, extraAttributes = {};
+				this.commitContent( objectNode, embedNode, paramMap, extraStyles, extraAttributes );
 
 				// Refresh the fake image.
 				var newFakeImage = editor.createFakeElement( objectNode || embedNode, 'cke_flash', 'flash', true );
+				newFakeImage.setAttributes( extraAttributes );
 				newFakeImage.setStyles( extraStyles );
 				if ( this.fakeImage )
@@ -573,5 +576,10 @@
 									],
 									setup : loadValue,
-									commit : commitValue
+									commit : function( objectNode, embedNode, paramMap, extraStyles, extraAttributes )
+									{
+										var value = this.getValue();
+										commitValue.apply( this, arguments );
+										value && ( extraAttributes.align = value );
+									}
 								},
 								{
Index: CKEditor/branches/versions/3.3.x/_source/plugins/flash/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/flash/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/flash/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/floatpanel/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/floatpanel/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/font/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/format/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/button.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/button.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/button.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/checkbox.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -92,5 +92,17 @@
 								element.setAttribute( 'value', value );
 							else
-								element.removeAttribute( 'value' );
+							{
+								if ( CKEDITOR.env.ie ) 
+								{ 
+									// Remove attribute 'value' of checkbox #4721. 
+									var checkbox = new CKEDITOR.dom.element( 'input' ); 
+									element.copyAttributes( checkbox, { value: 1 } ); 
+									checkbox.replace( element ); 
+									editor.getSelection().selectElement( checkbox ); 
+									data.element = checkbox;      
+								} 
+								else 
+									element.removeAttribute( 'value' );
+							}
 						}
 					},
Index: CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/form.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/form.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/form.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/hiddenfield.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/hiddenfield.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/forms/dialogs/hiddenfield.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
